# COVID testləri
Adilin məktəbinə COVID virusunun yeni dalğası gəlib. Məktəb bu virusun daha da yayılmasının qarışısını almaq üçün hər uşağın tüpürcəyindən nümunə götürərək antigen testləri etmək qərarına gəldi.

Müəllimlər bu testlərin necə edildiyini uzun müddət əvvəl unudublar, ona görə də Adil özü bunu etmək üçün könüllü oldu.

O, $N$ şagirddən nümunə götürdü (məxfiliyə görə yalnızca $0$'dan $N-1$'ə qədər olan identifikasiya nömrələrini bilir) və onun tapşırığı hansı testlərin pozitiv çıxdığını təyin etməkdir. Təəssüf ki, uşaqların hamısını test etməyin çox uzun və bezdirici tapşırıq olduğunu başa düşəndə artıq çox gec idi. Lakin, testləri bir-bir yerinə yetirməkdənsə, daha ağıllı bir yolun oluğunu öyrəndi. Əgər o nümunələrin hansısa alt çoxluğunu götürsə və onları qarışdırdıqdan sonra test etsə, hamısının nəticəsinin neqativ olduğunu, yoxsa onların arasında ən az bir dənə pozitiv nəticə olduğunu başa düşə bilər. O, bundan istifadə edərək yerinə yetirməli olduğu testlərin sayını azalda bilər!

Hər nümunədə kifayət qədər tüpürcək olduğuna görə nümunələri istədiyi sayda testdə istifadə edə bilər. Əlavə olaraq, hər bir test tam dəqiq nəticə verir, yəni mümkün deyil ki müxtəlif testlər eyni nümunə üçün müxtəlif cavablar versin. 

Bu şərtləri nəzərə almaqla prosesi optimizasiya edərək mümkün qədər az sayda testdən istifadə etmək istəyir. Lakin, o test etməklə məşğuldur, ona görə də optimizasiya hissəsi sizə düşür.

Yerli statistikalardan bilinir ki, hər hansı şagirdin nəticəsinin pozitiv olmaq ehtimalı $P$'dir, və bir nümunənin pozitiv və ya neqativ olmasının başqa nümunənin nəticəsinə heç bir təsiri yoxdur. Yerinə yetirəcəyi testləri optimallaşdırmaq üçün bu məlumatdan istifadə edə bilərsiniz. 

## Kommunikasiya

Bu tapşırıq interaktivdir.

Sizin proqramınız müxtəlif testlər üzərində yoxlanılacaq. Bir testin parçası olaraq sizin proqramınız $T$ müxtəlif vəziyyəti həll etməli olacaq. Bütün vəziyyətlərdə $N$ və $P$ eyni olacaq, lakin kimlərin pozitiv olduğu (çox böyük ehtimal) müxtəlif olacaq.

İstəsəniz lazımi protokolu özünüz yaza bilərsiniz, və ya verilmiş şablon koddan istifadə edə bilərsiniz. Şablon kodu CMS'də `template.cpp` adı ilə tapa bilərsiniz.

### Protokol

İlk olaraq sizin kodunuz standart girişdən boşluqlarla ayrılmış $N$ tam ədədini, $P$ həqiqi ədədini, və $T$ tam ədədini — insanların sayını, nümunənin pozitiv olmağının ehtimalını, və vəziyyətlərin sayını oxuyacaq. 

Daha sonra proqram standart çıxışa sorğularını verə bilər. Hər sorğu bir sətirdə `Q` hərfi, boşluq, və $N$ uzunluqlu $s$ string'dən ibarət olmalıdır. Adil əgər $i$'ci adamı testə əlavə etmək istəyirsə $s_i$ `1` olmalıdır, əks halda `0` olmalıdır. Bu sətri çıxışa verdikdən sonra standart çıxışı flush etməli, daha sonra bir hərf oxumalısınız. Əgər test olunan adamlardan ən az biri pozitiv olarsa bu hərf `P`, əks halda `N` olacaq. 

Sizin proqramınız cavab təqdim etmək istədikdə çıxışa bir sətirdə `A` hərfi, boşluq, $N$ uzunluqlu $s$ string'i verəcək. Əgər $i$'ci adamın nəticəsi pozitiv olarsa $s_i$ `1` olmalıdır, əks halda `0` olmalıdır. Bu sətri çıxışa verdikdən sonra standart çıxışı flush etməli, daha sonra bir hərf oxumalısınız.

Əgər oxuduğunuz hərf `C` olarsa, deməli cavabınız doğrudur. Bu halda proqramınız növbəti vəziyyət ilə bağlı sorğularla davam edə bilər, və ya əgər artıq $T$'ci cavabınız idisə proqramınız dayanmalıdır. 

Əgər oxuduğunuz hərf `W` olarsa, deməli cavabınız yanlışdır. Bu halda proqramınız dayanmalıdır. 

Qeyd edək ki, `W` hərfini oxuduqdan sonra proqramı dayandırmağınız CMS'dən düzgün rəy almağınız üçün önəmlidir. Əgər proqramınız davam edərsə, xarab ola bilər və ya digər lazımsız bir rəy ala bilər.

### Şablon

Əgər `template.cpp` faylındakı protokol üzərindən işləmək istəsəniz, bu zaman `std::vector<bool> find_positive()` funksiyasını doldurmalısınız. Hər vəziyyət üçün bu funksiya bir dəfə çağırılacaq və $N$ uzunluqlu bool vector'u qaytarmalıdır. Əgər $i$'ci şagirdin nəticəsi pozitiv olarsa `true`, əks halda `false` qaytarmalıdır. 

`bool test_students(std::vector<bool> mask)` funksiyasından istifadə edərək nümunələrin hansısa alt çoxluğu üzərində test yerinə yetirə bilərsiniz. Bu funksiyaya $N$ uzunluqlu bool vector'u göndərirsiniz — $i$'ci nümunəni yoxlamaq istəsəniz bu zaman $i$'ci element `true`, əks halda `false` olmalıdır. Funksiya bu alt çoxluqdakı ən az bir nəfər pozitiv olarsa `true`, əks halda `false` qaytaracaq.

Şərtdəki $N$ və $P$ ədədlərini göstərən qlobal `N` və `P` dəyişənlərini də istifadə edə bilərsiniz. `main` funksiyasındaki ilk `scanf` çağırışından sonra istənilən hazırlıq işlərini görə bilərsiniz.

## Giriş verilənləri

Tapşırığın interaktoru adaptiv deyil, yəni hər bir tüpürcək nümunəsinin nəticəsi proqram işlədilməzdən əvvəl təyin olunur. Əlavə olaraq, hər bir nümunənin nəticəsi müstəqil şəkildə $P$ ehtimalı ilə tam ixtiyari ədəd istifadəsi ilə təyin olunub. 

## Alt tapşırıqlar və balın hesablanması

İki alt tapşırıq var.

### Birinci alt tapşırıq (10 bal)

- $N = 1\,000$
- $T = 1$
- $0 \le P \le 1$

Həll o zaman qəbul olunur ki, hər bir test üçün ən çox $2 \cdot N$ sorğu soruşsun, və düzgün cavab versin.

### İkinci alt tapşırıq (90  bal)

- $N = 1\,000$
- $T = 300$
- $0.001 \le P \le 0.2$

Bu alt tapşırıqda qismi bal hesablama istifadə olunur.

Hər hansı vəziyyət üçün səhv cavab tapsanız, sıfır bal alırsınız. Əks halda test üçün alacağınız bal, vəziyyətlər üçün istifadə etdiyiniz sorğu sayının ədədi ortasından asılı olacaq. Ümumən, az sorğu sayı çox bal mənasına gəlir. $Q$ sizin proqramınızın bütün vəziyyətlər üçün istifadə etdiyi sorğuların sayının ədədi ortasının vergüldən sonra 1 rəqəmə qədər yuvarlaşdırılması olsun. Hər test üçün biz $F$ ədədi hesablamışıq (aşağıda qeyd olunub). Verilmiş test üçün qazanacağınız bal aşağıdakı formada hesablanır:

- Əgər $Q > F\cdot 10$ olarsa, o zaman 0 bal alacaqsınız (wrong answer).
- Əgər $F < Q \leq 10 \cdot F$ olarsa, qazanağınız bal aşağıdakı düstur ilə hesablanacaq:
	$$ 90 \cdot \frac{F}{F + 4 \cdot (Q-F)} $$
- Əgər $Q \leq F$ olarsa, tam 90 bal alacaqsınız. 

Sizin həlliniz müxtəlif testlərdə müxtəlif $P$ dəyərləri üçün yoxlanılacaq. Bu məsələ üçün balınız testlər arasındakı (yəni bütün $P$ dəyərləri arasında) ən kiçik bala bərabər olacaq.


Testlər aşağıdakı kimidir:

| $P$      | $F$      |
|----------|---------:|
|0.001     |      15.1|
|0.005256  |      51.1|
|0.011546  |      94.9|
|0.028545  |     191.5|
|0.039856  |     246.3|
|0.068648  |     366.2|
|0.104571  |     490.3|
|0.158765  |     639.1|
|0.2       |     731.4|

Yoxlama sistemi hər bir test üçün rəy bildirəcək. Əgər sıfır olmayan bir bal almısınızsa, bu rəyin içində həmin test üçün $Q$ dəyərini də qaytaracaq.


### Nümunə interaksiya

Qreyder ilə nümunə interaksiya aşağıdakı kimidir. Qeyd edək ki, bu $N$ və $T$ ədədəri alt tapşırıqlarda və testlərdə rast gəlinmir. Hər sətirdən sonra çıxışı flush etməyi unutmayın.

| Sizin giriş verilənləri | Sizin çıxış verilənləri    |
|------------|----------------|
| `10 0.4 2` |                |
|            | `Q 1000000000` |
| `P`        |                |
|            | `Q 0000001000` |
| `P`        |                |
|            | `Q 0000000001` |
| `P`        |                |
|            | `Q 0111110110` |
| `N`        |                |
|            | `A 1000001001` |
| `C`        |                |
|            | `A 0000000000` |
| `W`        | &nbsp;         |

Proqram birinci vəziyyəti düzgün həll etdi, lakin ikincini düz həll edə bilmədi. Orada cavab `1100010010` olmalı idi (hansı ki proqram bilə bilməzdi, çünki heç bir sorğu etmədi). Başqa bir vəziyyət olsa idi belə, proqram burada dayanmalıdır.
